/* $Id: visor.cpp 96 2009-06-07 16:09:35Z gbv $ */
/***************************************************************************
 *   Copyright (C) 2009 by Guillermo Ballester Valor                       *
 *   gbv@oxixares.com                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "visor.h"

// funciones de la clase met_report

met_report::met_report()
{
  memset(this, 0, sizeof(class met_report));
};

met_report::met_report(struct real_data& r)
{
  mask = r.mask;
  datime = r.datime;
  interval = r.interval;
  hum_int = r.hum_int;
  temp_int = r.temp_int;
  tdew_int = r.tdew_int;
  hum_out = r.hum_out;
  temp_out = r.temp_out;
  tdew_out = r.tdew_out;
  press = r.pres0;
  sea_press = r.press;
  wspd = r.wspd;
  wgust = r.wgust;
  wdir = r.wdir;
  wdgust = r.wdir;
  rain = r.prec;
}

met_report::met_report(struct obs_data *o, met_station& e)
{
  struct real_data r;
  obsdata_to_realdata(&r, o, e.calp, e.conf.altitude);
  mask = r.mask;
  datime = r.datime;
  interval = r.interval;
  hum_int = r.hum_int;
  temp_int = r.temp_int;
  tdew_int = r.tdew_int;
  hum_out = r.hum_out;
  temp_out = r.temp_out;
  tdew_out = r.tdew_out;
  press = r.pres0;
  sea_press = r.press;
  wspd = r.wspd;
  wgust = r.wgust;
  wdir = r.wdir;
  wdgust = r.wdir;
  rain = r.prec;
}

//copy constructor
met_report::met_report (const met_report &r)
{
  mask = r.mask;
  datime = r.datime;
  interval = r.interval;
  hum_int = r.hum_int;
  temp_int = r.temp_int;
  tdew_int = r.tdew_int;
  hum_out = r.hum_out;
  temp_out = r.temp_out;
  tdew_out = r.tdew_out;
  press = r.press;
  sea_press = r.sea_press;
  wspd = r.wspd;
  wgust = r.wgust;
  wdir = r.wdir;
  wdgust = r.wdir;
  rain = r.rain;
}

// overload of =
met_report& met_report::operator= (const met_report &r)
{
  mask = r.mask;
  datime = r.datime;
  interval = r.interval;
  hum_int = r.hum_int;
  temp_int = r.temp_int;
  tdew_int = r.tdew_int;
  hum_out = r.hum_out;
  temp_out = r.temp_out;
  tdew_out = r.tdew_out;
  press = r.press;
  sea_press = r.sea_press;
  wspd = r.wspd;
  wgust = r.wgust;
  wdir = r.wdir;
  wdgust = r.wdir;
  rain = r.rain;
  return *this;
}


// Funciones de la clase met_station

void met_station::set_mask (int m)
{
  mask = m;
}

met_station::met_station (int m)
{
  mask = m;
}

met_station::met_station () {};

int met_station::get_station_conf(void)
{
  if (strlen(confile.c_str()))
    return read_station_conf(&conf, confile.c_str());
  else
    return 0;
}

int met_station::open_met_db(void)
{
  return open_db(&db, NULL, DB_RDONLY, NULL, conf.dbfile);
}

int met_station::close_met_db(void)
{
  return close_db(db, NULL);
}

int met_station::get_station_cal(void)
{
  if (nocal == string ("no"))
    {
      calp = &cal;
      return read_cal_points(calp, conf.calfile);
    }
  else
    {
      calp = NULL;
      return 0;
    }
}
