/* $Id: visor_html.cpp 96 2009-06-07 16:09:35Z gbv $ */
/***************************************************************************
 *   Copyright (C) 2009 by Guillermo Ballester Valor                       *
 *   gbv@oxixares.com                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "visor.h"

char *dirwtxt(char *cdir, double wdir)
{
  if (wdir > 360.0 || wdir < 0.0)
    return NULL;
  if (wdir > 348.75 || wdir <= 11.25)
    strcpy(cdir,"N");
  else if ( wdir > 11.25 && wdir <= 33.75)
    strcpy(cdir,"NNE");
  else if ( wdir > 33.75 && wdir <= 56.25)
    strcpy(cdir,"NE");
  else if ( wdir > 56.25 && wdir <= 78.75)
    strcpy(cdir,"ENE");
  else if ( wdir > 78.75 && wdir <= 101.25)
    strcpy(cdir,"E");
  else if ( wdir > 101.25 && wdir <= 123.75)
    strcpy(cdir,"ESE");
  else if ( wdir > 123.75 && wdir <= 146.25)
    strcpy(cdir,"SE");
  else if ( wdir > 146.25 && wdir <= 168.75)
    strcpy(cdir,"SSE");
  else if ( wdir > 168.75 && wdir <= 191.25)
    strcpy(cdir,"S");
  else if ( wdir > 191.25 && wdir <= 213.75)
    strcpy(cdir,"SSW");
  else if ( wdir > 213.75 && wdir <= 236.25)
    strcpy(cdir,"SW");
  else if ( wdir > 236.25 && wdir <= 258.75)
    strcpy(cdir,"WSW");
  else if ( wdir > 258.75 && wdir <= 281.25)
    strcpy(cdir,"W");
  else if ( wdir > 281.25 && wdir <= 303.75)
    strcpy(cdir,"WNW");
  else if ( wdir > 303.75 && wdir <= 326.25)
    strcpy(cdir,"NW");
  else if ( wdir > 326.25 && wdir <= 348.75)
    strcpy(cdir,"NNW");
  return cdir;
}

int show_met_report_txt(met_report& r, met_station& e)
{
  char fecha[32],aux[128];
  struct tm tim;
  gmtime_r(&r.datime, &tim);
  strftime(fecha,32,"%d/%m/%Y a %H:%M UTC", &tim);
  sprintf(aux,"<strong>Último dato disponible: %s</strong>",fecha);
  cout << table().set("bgcolor","#FF5555").set("border","0").set("cellspacing","1").set("align","center") << endl;
  cout << caption(aux) << endl;
  cout << tr().set("bgcolor","#DDDDFF").set("align","center") << endl;
  cout << th(" ") << endl;
  cout << th("Temp <br> (C)") << endl;
  cout << th("Hrel <br> %") << endl;
  cout << th("Troc <br> (C)") << endl;
  cout << th("Racha <br> (Km/h)") << endl;
  cout << th("Direc.<br> Racha") << endl;
  cout << th("Vmed <br>(Km/h)") << endl;
  cout << th("Direc. ") << endl;
  cout << th("Pres. <br>(mb)") << endl;
  cout << th("P.mar <br>(mb)") << endl;
  cout << tr() << endl;

  cout << tr().set("bgcolor","#DDFFDD").set("align","right") << endl;
  cout << td("Exterior") << endl;
  sprintf(aux,"%.1lf",r.temp_out);
  cout << td(b(tt(aux))) << endl;
  sprintf(aux,"%.0lf",r.hum_out);
  cout << td(b(tt(aux))) << endl;
  sprintf(aux,"%.1lf",r.tdew_out);
  cout << td(b(tt(aux))) << endl;
  sprintf(aux,"%.1lf",r.wgust);
  cout << td(b(tt(aux))).set("rowspan","2") << endl;
  sprintf(aux,"%.1lf",r.wdgust);
  sprintf(aux,"%s",dirwtxt(fecha,r.wdgust));
  cout << td(b(tt(aux))).set("rowspan","2").set("align","center") << endl;
  sprintf(aux,"%.1lf",r.wspd);
  cout << td(b(tt(aux))).set("rowspan","2") << endl;
  sprintf(aux,"%s",dirwtxt(fecha,r.wdir));
  cout << td(b(tt(aux))).set("rowspan","2").set("align","center") << endl;
  sprintf(aux,"%.1lf",r.press);
  cout << td(b(tt(aux))).set("rowspan","2").set("bgcolor","#FFFFDD") << endl;
  sprintf(aux,"%.1lf",r.sea_press);
  cout << td(b(tt(aux))).set("rowspan","2").set("bgcolor","#FFFFDD") << endl;
  cout << tr() << endl;

  cout << tr().set("bgcolor","#FFFFDD").set("align","right") << endl;
  cout << td("Interior") << endl;
  sprintf(aux,"%.1lf",r.temp_int);
  cout << td(b(tt(aux))) << endl;
  sprintf(aux,"%.0lf",r.hum_int);
  cout << td(b(tt(aux))) << endl;
  sprintf(aux,"%.1lf",r.tdew_int);
  cout << td(b(tt(aux))) << endl;
  cout << tr() << endl;
  cout << table() << endl;
  return 1;
}

int print_info_station(met_station& e)
{
   char aux[128], lat[4], lon[4];

   cout << table().set("bgcolor","#FF5555").set("border","0").set("cellspacing","1").set("align","center") << endl;
   cout << tr().set("bgcolor","#CCDDFF") << endl;
   cout << td(b(e.conf.name)).set("align","center") << endl;
   if (e.conf.latitude > 0.0)
     strcpy(lat,"N");
   else
     strcpy(lat,"S");
   if (e.conf.longitude > 0.0)
     strcpy(lon,"E");
   else
     strcpy(lon,"W");

   sprintf(aux,"Altitud: %.0lf m | Latitud: %.4lf %s | Longitud: %.4lf %s", e.conf.altitude, fabs(e.conf.latitude),
      lat, fabs(e.conf.longitude), lon);  
   cout << tr() << endl;
   cout << tr().set("bgcolor","#CCDDFF") << endl;
   cout << td(b(tt(aux))) << endl;
   cout << tr() << endl;
   cout << table() << br() << endl;
   return 1;
}


// todo en una fila, para resúmenes
int print_row_metstat(met_stat& S, int viewmask)
{
  struct tm tmx;
  double x;
  char *c, aux[128], fech0[32], fecha[32], cmax[8], cmin[8], cmed[8];

  strcpy(cmax, "#FFEEDD");
  strcpy(cmin, "#DDEEFF");
  strcpy(cmed, "#DDFFEE");

  // inicio de fila
  cout << tr().set("align","right") << endl;

  // periodo
  if ((S.end - S.begin) > 86400)
    {
      gmtime_r(&S.begin, &tmx);
      strftime(fech0, 32, "%Y%m%d%H%M", &tmx);
      c = aux + sprintf(aux,"%s -", fech0);
      gmtime_r(&S.end, &tmx);
      strftime(fech0, 32, "%Y%m%d%H%M", &tmx);
      c += sprintf(c,"%s", fech0);
    }
  else if ((S.end - S.begin) < 86399)
    {
      gmtime_r(&S.begin, &tmx);
      strftime(fech0, 32, "%Y/%m/%d %H:%M", &tmx);
      c = aux + sprintf(aux,"%s -", fech0);
      gmtime_r(&S.end, &tmx);
      strftime(fech0, 32, "%H:%M", &tmx);
      c += sprintf(c,"%s", fech0);
    }
  else
    {
      gmtime_r(&S.begin, &tmx);
      strftime(fech0, 32, "%Y/%m/%d", &tmx);
      sprintf(aux,"%s", fech0);
    }
  cout << td(b(tt(aux))).set("align", "center").set("bgcolor","#DDDDDD") << endl;

  // Temperetura externa
  if (viewmask && MMASK_TEMP_EXT)
    {
      if (S.mask & MMASK_TEMP_EXT)
        {
          sprintf( aux, "%.1lf", S.temp_out.vmax);
          cout << td(b(tt(aux))).set("bgcolor",cmax) << endl;
          sprintf( aux, "%.1lf", S.temp_out.vmin);
          cout << td(b(tt(aux))).set("bgcolor",cmin) << endl;
          sprintf( aux, "%.1lf", (S.temp_out.acum / S.temp_out.tiempo));
          cout << td(b(tt(aux))).set("bgcolor",cmed) << endl;
        }
      else
        {
          cout << td(" ") << endl;
          cout << td(" ") << endl;
          cout << td(" ") << endl;
        }
    }
  // Humedad externa
  if (viewmask & MMASK_HUM_EXT)
    {
      if (S.mask & MMASK_HUM_EXT)
        {
          sprintf( aux, "%.1lf", S.hum_out.vmax);
          cout << td(b(tt(aux))).set("bgcolor",cmax) << endl;
          sprintf( aux, "%.1lf", S.hum_out.vmin);
          cout << td(b(tt(aux))).set("bgcolor",cmin) << endl;
          sprintf( aux, "%.1lf", (S.hum_out.acum / S.hum_out.tiempo));
          cout << td(b(tt(aux))).set("bgcolor",cmed) << endl;
        }
      else
        {
          cout << td(" ") << endl;
          cout << td(" ") << endl;
          cout << td(" ") << endl;
        }
    }

  // Presion al nivel del mar
  if (viewmask & MMASK_PRES)
    {
      if (S.mask & MMASK_PRES)
        {
          sprintf( aux, "%.1lf", S.sea_press.vmax);
          cout << td(b(tt(aux))).set("bgcolor",cmax) << endl;
          sprintf( aux, "%.1lf", S.sea_press.vmin);
          cout << td(b(tt(aux))).set("bgcolor",cmin) << endl;
          sprintf( aux, "%.1lf", (S.sea_press.acum / S.sea_press.tiempo));
          cout << td(b(tt(aux))).set("bgcolor",cmed) << endl;
        }
      else
        {
          cout << td(" ") << endl;
          cout << td(" ") << endl;
          cout << td(" ") << endl;
        }
    }

  // Viento
  if ((viewmask & MMASK_WDIR) && (viewmask & MMASK_WSPD))
    {
      if ((S.mask & MMASK_WDIR) && (S.mask & MMASK_WSPD))
        {
          sprintf( aux, "%.1lf", S.wgust.vmax);
          cout << td(b(tt(aux))).set("bgcolor",cmax) << endl;
          cout << td(b(tt(dirwtxt(fecha, S.wgust.aux)))).set("bgcolor",cmax).set("align","center") << endl;

          sprintf( aux, "%.1lf", (S.wspd.acum / S.wspd.tiempo));
          cout << td(b(tt(aux))).set("bgcolor",cmed) << endl;
          if (S.wdir.vmin != 0.0 || S.wdir.vmax != 0.0)
            {
              x = atan2(S.wdir.vmax, S.wdir.vmin) * RAD2GRAD;
              if (x < 0.0)
                x += 360.0;
              cout << td(b(tt(dirwtxt(fecha, x)))).set("bgcolor",cmed).set("align","center") << endl;
            }
          else
            cout << td(b(tt("---"))).set("bgcolor",cmed).set("align","center") << endl;
        }
      else
        {
          cout << td(" ") << endl;
          cout << td(" ") << endl;
          cout << td(" ") << endl;
          cout << td(" ") << endl;
        }
    }

  // precipitacion
  if (viewmask & MMASK_RAIN)
    {
      if (S.mask & MMASK_RAIN)
        {
          if (S.rain.vmax > 0.0)
            {
              sprintf( aux, "%.1lf", S.rain.vmax);
              cout << td(b(tt(aux))).set("bgcolor",cmax) << endl;
            }
          else
            {
              cout << td(b(tt("---"))).set("bgcolor",cmax).set("align","center") << endl;
            }
          sprintf( aux, "%.1lf", S.rain.acum);
          cout << td(b(tt(aux))).set("bgcolor",cmed) << endl;
        }
      else
        {
          cout << td(" ") << endl;
          cout << td(" ") << endl;
        }
    }
  // fin de fila
  cout << tr() << endl;
  return 1;
}

int print_header_metstat(int viewmask)
{

  //inicio
  cout << tr().set("align","center").set("bgcolor","#DDDDFF") << endl;

  // fecha
  cout << th("Fecha").set("rowspan","2") << endl;

  // Fila 1

  // Temp. ext
  if (viewmask & MMASK_TEMP_EXT)
    cout << th("Temperatura (C)").set("colspan","3") << endl;

  // hum. ext
  if (viewmask & MMASK_HUM_EXT)
    cout << th("Humedad (%)").set("colspan","3") << endl;

  // presión
  if (viewmask & MMASK_PRES)
    cout << th("Presion n. mar (mb)").set("colspan","3") << endl;

  // viento
  if ((viewmask & MMASK_WSPD) && (viewmask & MMASK_WDIR))
    cout << th("Viento (Km/h)").set("colspan","4") << endl;

  // prec
  if (viewmask & MMASK_RAIN)
    cout << th("Precip. (mm)").set("colspan","2") << endl;

  cout << tr() << endl;
  cout << tr().set("align","center").set("bgcolor","#DDDDFF") << endl;


  // Temp. ext
  if (viewmask & MMASK_TEMP_EXT)
    {
      cout << th("Max") << endl;
      cout << th("Min") << endl;
      cout << th("Med") << endl;
    }

  // Hum. ext
  if (viewmask & MMASK_HUM_EXT)
    {
      cout << th("Max") << endl;
      cout << th("Min") << endl;
      cout << th("Med") << endl;
    }

  // Presion
  if (viewmask & MMASK_PRES)
    {
      cout << th("Max") << endl;
      cout << th("Min") << endl;
      cout << th("Med") << endl;
    }

  if ((viewmask & MMASK_WSPD) && (viewmask & MMASK_WDIR))
    {
      cout << th("Racha") << endl;
      cout << th("dir") << endl;
      cout << th("Med") << endl;
      cout << th("dir") << endl;
    }

  // prec
  if (viewmask & MMASK_RAIN)
    {
      cout << th("Imax") << endl;
      cout << th("Tot") << endl;
    }

  //final
  cout << tr() << endl;

  return 1;
}


// imprime una tabla con una columna por día
int print_tableres(met_station& e, int tbegin, int nd, int viewmask)
{
  int i;
  time_t ti, te;
  met_stat S;
  char aux[128];

  // table
  cout << br() << endl;
  cout << table().set("bgcolor","#FF5555").set("border","0").set("cellspacing","1").set("align","center") << endl;
  sprintf(aux, "Resumen de los %d días anteriores", nd);
  cout << caption(strong(aux)) << endl;
  print_header_metstat(viewmask); // header

  // and then the rows 
  for (i = 0; i < nd; i++)
  {
     ti = tbegin - (i + SHOWLAST) * 86400;
     te = ti + 86399;
     if (get_summary_data(S, ti, te, e))
       print_row_metstat(S, viewmask);
  }

  cout << table() << endl;
  return 1;
}


