/* $Id: visor_html2.cpp 96 2009-06-07 16:09:35Z gbv $ */
/***************************************************************************
 *   Copyright (C) 2009 by Guillermo Ballester Valor                       *
 *   gbv@oxixares.com                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "visor.h"


int print_met_stat(met_stat& S, int viewmask)
{
  double x;
  char *c, fecha[32], aux[256], fech0[32], fechh[32],cmax[8], cmin[8], cdate[8];
  struct tm tim;

  strcpy(cmax, "#FFEEDD");
  strcpy(cmin, "#DDEEFF");
  strcpy(cdate, "#DDDDDD");

  cout << br() << endl;

  if ((S.begin - S.end) > 86400)
    {
      strcpy(fech0,"%Y/%m/%d %H:%M UTC");
      strcpy(fechh,"Fecha / hora");
    }
  else
    {
      strcpy(fech0,"%H:%M UTC");
      strcpy(fechh,"Hora");
    }

  cout << "<TABLE bgcolor='#CCDDFF' border='0' align='center'>" << endl;

  c = aux + sprintf(aux, "<caption><strong>Resumen del periodo ");
  gmtime_r(&S.begin, &tim);
  strftime(fecha,32,"%Y/%m/%d %H:%M ", &tim);
  c += sprintf(c, "%s", fecha);
  gmtime_r(&S.end, &tim);
  strftime(fecha,32,"%Y/%m/%d %H:%M ", &tim);
  c += sprintf(c, "- %s</strong></caption>", fecha);
  cout << aux << endl;

  cout << "<TR>" << "<TD>" << endl;

  cout << table().set("bgcolor","#FF5555").set("border","0").set("cellspacing","1").set("align","center") << endl;
  cout << caption("<strong>Temperatura, humedad y presión</strong>") << endl;
  cout << tr().set("bgcolor","#DDDDFF").set("align","center") << endl;
  cout << th(" ") << endl;
  cout << th("Máx.") << endl;
  cout << th(fechh) << endl;
  cout << th("Min") << endl;
  cout << th(fechh) << endl;
  cout << th("Media") << endl;
  cout << tr() << endl;


  if (S.mask & MMASK_TEMP_EXT & viewmask)
    {
      cout << tr().set("bgcolor","#DDFFDD").set("align","right") << endl;
      cout << td(b("Temperatura Exterior")).set("align","center") << endl;
      gmtime_r(&(S.temp_out.tvmax), &tim);
      strftime(aux, 32, fech0, &tim);
      sprintf( fecha, "%.1lf C", S.temp_out.vmax);
      cout << td(b(tt(fecha))).set("bgcolor",cmax) << endl;
      cout << td(b(tt(aux))).set("bgcolor",cdate) << endl;

      gmtime_r(&(S.temp_out.tvmin), &tim);
      strftime(aux, 32, fech0, &tim);
      sprintf( fecha, "%.1lf C", S.temp_out.vmin);
      cout << td(b(tt(fecha))).set("bgcolor",cmin) << endl;
      cout << td(b(tt(aux))).set("bgcolor",cdate) << endl;
      sprintf( aux, "%.1lf C", (S.temp_out.acum / S.temp_out.tiempo));
      cout << td(b(tt(aux))) << endl;
      cout << tr() << endl;
    }

  if (S.mask & MMASK_HUM_EXT & viewmask)
    {
      cout << tr().set("bgcolor","#DDFFDD").set("align","right") << endl;
      cout << td(b("Humedad Exterior")).set("align","center") << endl;
      gmtime_r(&(S.hum_out.tvmax), &tim);
      strftime(aux, 32, fech0, &tim);
      sprintf( fecha, "%.1lf %%", S.hum_out.vmax);
      cout << td(b(tt(fecha))).set("bgcolor",cmax) << endl;
      cout << td(b(tt(aux))).set("bgcolor",cdate) << endl;

      gmtime_r(&(S.hum_out.tvmin), &tim);
      strftime(aux, 32, fech0, &tim);
      sprintf( fecha, "%.1lf %%", S.hum_out.vmin);
      cout << td(b(tt(fecha))).set("bgcolor",cmin) << endl;
      cout << td(b(tt(aux))).set("bgcolor",cdate) << endl;
      sprintf( aux, "%.1lf %%", (S.hum_out.acum / S.hum_out.tiempo));
      cout << td(b(tt(aux))) << endl;
      cout << tr() << endl;
    }

  if ((S.mask & MMASK_TEMP_EXT & viewmask) && (S.mask & MMASK_HUM_EXT & viewmask))
    {
      cout << tr().set("bgcolor","#DDFFDD").set("align","right") << endl;
      cout << td(b("Punto de rocío Ext.")).set("align","center") << endl;
      gmtime_r(&(S.tdew_out.tvmax), &tim);
      strftime(aux, 32, fech0, &tim);
      sprintf( fecha, "%.1lf C", S.tdew_out.vmax);
      cout << td(b(tt(fecha))).set("bgcolor",cmax) << endl;
      cout << td(b(tt(aux))).set("bgcolor",cdate) << endl;

      gmtime_r(&(S.tdew_out.tvmin), &tim);
      strftime(aux, 32, fech0, &tim);
      sprintf( fecha, "%.1lf C", S.tdew_out.vmin);
      cout << td(b(tt(fecha))).set("bgcolor",cmin) << endl;
      cout << td(b(tt(aux))).set("bgcolor",cdate) << endl;
      sprintf( aux, "%.1lf C", (S.tdew_out.acum / S.tdew_out.tiempo));
      cout << td(b(tt(aux))) << endl;
      cout << tr() << endl;
    }


  if (S.mask & MMASK_TEMP_INT & viewmask)
    {
      cout << tr().set("bgcolor","#FFFFDD").set("align","right") << endl;
      cout << td(b("Temperatura Interior")).set("align","center") << endl;
      gmtime_r(&(S.temp_int.tvmax), &tim);
      strftime(aux, 32, fech0, &tim);
      sprintf( fecha, "%.1lf C", S.temp_int.vmax);
      cout << td(b(tt(fecha))).set("bgcolor",cmax) << endl;
      cout << td(b(tt(aux))).set("bgcolor",cdate) << endl;

      gmtime_r(&(S.temp_int.tvmin), &tim);
      strftime(aux, 32, fech0, &tim);
      sprintf( fecha, "%.1lf C", S.temp_int.vmin);
      cout << td(b(tt(fecha))).set("bgcolor",cmin) << endl;
      cout << td(b(tt(aux))).set("bgcolor",cdate) << endl;
      sprintf( aux, "%.1lf C", (S.temp_int.acum / S.temp_int.tiempo));
      cout << td(b(tt(aux))) << endl;
      cout << tr() << endl;
    }

  if (S.mask & MMASK_HUM_INT & viewmask)
    {
      cout << tr().set("bgcolor","#FFFFDD").set("align","right") << endl;
      cout << td(b("Humedad Interior")).set("align","center") << endl;
      gmtime_r(&(S.hum_int.tvmax), &tim);
      strftime(aux, 32, fech0, &tim);
      sprintf( fecha, "%.1lf %%", S.hum_int.vmax);
      cout << td(b(tt(fecha))).set("bgcolor",cmax) << endl;
      cout << td(b(tt(aux))).set("bgcolor",cdate) << endl;

      gmtime_r(&(S.hum_int.tvmin), &tim);
      strftime(aux, 32, fech0, &tim);
      sprintf( fecha, "%.1lf %%", S.hum_int.vmin);
      cout << td(b(tt(fecha))).set("bgcolor",cmin) << endl;
      cout << td(b(tt(aux))).set("bgcolor",cdate) << endl;
      sprintf( aux, "%.1lf %%", (S.hum_int.acum / S.hum_int.tiempo));
      cout << td(b(tt(aux))) << endl;
      cout << tr() << endl;
    }

  if ((S.mask & MMASK_TEMP_INT & viewmask) && (S.mask & MMASK_HUM_INT & viewmask))
    {
      cout << tr().set("bgcolor","#FFFFDD").set("align","right") << endl;
      cout << td(b("Punto de rocío Int.")).set("align","center") << endl;
      gmtime_r(&(S.tdew_int.tvmax), &tim);
      strftime(aux, 32, fech0, &tim);
      sprintf( fecha, "%.1lf C", S.tdew_int.vmax);
      cout << td(b(tt(fecha))).set("bgcolor",cmax) << endl;
      cout << td(b(tt(aux))).set("bgcolor",cdate) << endl;

      gmtime_r(&(S.tdew_int.tvmin), &tim);
      strftime(aux, 32, fech0, &tim);
      sprintf( fecha, "%.1lf C", S.tdew_int.vmin);
      cout << td(b(tt(fecha))).set("bgcolor",cmin) << endl;
      cout << td(b(tt(aux))).set("bgcolor",cdate) << endl;
      sprintf( aux, "%.1lf C", (S.tdew_int.acum / S.tdew_int.tiempo));
      cout << td(b(tt(aux))) << endl;
      cout << tr() << endl;
    }

  if (S.mask & MMASK_PRES & viewmask)
    {
      cout << tr().set("bgcolor","#FFFFDD").set("align","right") << endl;
      cout << td(b("Presión atmosférica")).set("align","center") << endl;
      gmtime_r(&(S.press.tvmax), &tim);
      strftime(aux, 32, fech0, &tim);
      sprintf( fecha, "%.1lf mb", S.press.vmax);
      cout << td(b(tt(fecha))).set("bgcolor",cmax) << endl;
      cout << td(b(tt(aux))).set("bgcolor",cdate) << endl;

      gmtime_r(&(S.press.tvmin), &tim);
      strftime(aux, 32, fech0, &tim);
      sprintf( fecha, "%.1lf mb", S.press.vmin);
      cout << td(b(tt(fecha))).set("bgcolor",cmin) << endl;
      cout << td(b(tt(aux))).set("bgcolor",cdate) << endl;
      sprintf( aux, "%.1lf mb", (S.press.acum / S.press.tiempo));
      cout << td(b(tt(aux))) << endl;
      cout << tr() << endl;
    }

  if (S.mask & MMASK_PRES & viewmask)
    {
      cout << tr().set("bgcolor","#FFFFDD").set("align","right") << endl;
      cout << td(b("Presión niv. mar")).set("align","center") << endl;
      gmtime_r(&(S.sea_press.tvmax), &tim);
      strftime(aux, 32, fech0, &tim);
      sprintf( fecha, "%.1lf mb", S.sea_press.vmax);
      cout << td(b(tt(fecha))).set("bgcolor",cmax) << endl;
      cout << td(b(tt(aux))).set("bgcolor",cdate) << endl;

      gmtime_r(&(S.sea_press.tvmin), &tim);
      strftime(aux, 32, fech0, &tim);
      sprintf( fecha, "%.1lf mb", S.sea_press.vmin);
      cout << td(b(tt(fecha))).set("bgcolor",cmin) << endl;
      cout << td(b(tt(aux))).set("bgcolor",cdate) << endl;
      sprintf( aux, "%.1lf mb", (S.sea_press.acum / S.sea_press.tiempo));
      cout << td(b(tt(aux))) << endl;
      cout << tr() << endl;
    }
  cout << table() << endl;
 
  cout << "</TD>" << "</TR>" << endl;

  if ((S.mask & MMASK_WDIR & viewmask) && (S.mask & MMASK_WSPD & viewmask))
    {
      cout << "<TR>" << "<TD>" << endl;
      cout << table().set("bgcolor","#FF5555").set("border","0").set("cellspacing","1").set("align","center") << endl;
      cout << caption("<strong>Viento</strong>") << endl;
      cout << tr().set("bgcolor","#DDDDFF").set("align","right") << endl;
      cout << td(" ") << endl;
      cout << td(b("Vel. Máx.<br>(Km/h)")).set("align","center") << endl;
      cout << td(b("Dir.")).set("align","center") << endl;
      cout << td(b(fechh)).set("align","center") << endl;
      cout << td(b("Vel. Med<br>(Km/h)")).set("align","center") << endl;
      cout << td(b("Dir.")).set("align","center") << endl;
      cout << tr() << endl;

      cout << tr().set("bgcolor","#DDDDFF").set("align","right") << endl;
      cout << td(b("Racha máxima")).set("align","center") << endl;
      gmtime_r(&(S.wgust.tvmax), &tim);
      strftime(aux, 32, fech0, &tim);
      sprintf( fecha, "%.1lf", S.wgust.vmax);
      cout << td(b(tt(fecha))).set("bgcolor",cmax) << endl;
      cout << td(b(tt(dirwtxt(fecha, S.wgust.aux)))).set("bgcolor",cmax).set("align","center") << endl;
      cout << td(b(tt(aux))).set("bgcolor",cdate) << endl;
      cout << td(" ") << endl;
      cout << td(" ") << endl;
      cout << tr() << endl;

      cout << tr().set("bgcolor","#DDDDFF").set("align","right") << endl;
      cout << td(b("Viento medio")).set("align","center") << endl;
      gmtime_r(&(S.wspd.tvmax), &tim);
      strftime(aux, 32, fech0, &tim);
      sprintf( fecha, "%.1lf", S.wspd.vmax);
      cout << td(b(tt(fecha))).set("bgcolor",cmax) << endl;
      cout << td(b(tt(dirwtxt(fecha, S.wspd.aux)))).set("bgcolor",cmax).set("align","center") << endl;
      cout << td(b(tt(aux))).set("bgcolor",cdate) << endl;
      sprintf( aux, "%.1lf", (S.wspd.acum / S.wspd.tiempo));
      cout << td(b(tt(aux))) << endl;
      if (S.wdir.vmin != 0.0 || S.wdir.vmax != 0.0)
      {
         x = atan2(S.wdir.vmax, S.wdir.vmin) * RAD2GRAD;
         if (x < 0.0)
           x += 360.0;
         cout << td(b(tt(dirwtxt(fecha, x)))).set("bgcolor",cmax).set("align","center") << endl;
      }
      else
         cout << td(b(tt("---"))).set("bgcolor",cmax).set("align","center") << endl;

      cout << tr() << endl;
      cout << table() << endl;

      cout << "</TD>" << "</TR>" << endl;
    }

    if (S.mask & MMASK_RAIN & viewmask)
    {
      cout << "<TR>" << "<TD>" << endl;
      cout << table().set("bgcolor","#FF5555").set("border","0").set("cellspacing","1").set("align","center") << endl;
      cout << caption("<strong>Precipitación</strong>") << endl;
      cout << tr().set("bgcolor","#DDDDFF").set("align","right") << endl;
      cout << td(b("Int. Máxima")).set("align","center") << endl;
      cout << td(b(fechh)).set("align","center") << endl;
      cout << td(b("Prec. Total")).set("align","center") << endl;
      cout << tr() << endl;
      cout << tr().set("bgcolor","#DDFFDD").set("align","right") << endl;
      gmtime_r(&(S.rain.tvmax), &tim);
      strftime(aux, 32, fech0, &tim);
      if (S.rain.vmax > 0.0)
      {
        sprintf( fecha, "%.1lf mm/h", S.rain.vmax);
        cout << td(b(tt(fecha))).set("bgcolor",cmax) << endl;
        cout << td(b(tt(aux))).set("bgcolor",cdate) << endl;
      }
      else
      {
        cout << td(b(tt("---"))).set("bgcolor",cmax).set("align","center") << endl;
        cout << td(b(tt("---"))).set("bgcolor",cdate).set("align","center") << endl;
      }
      sprintf( aux, "%.1lf mm", S.rain.acum);
      cout << td(b(tt(aux))) << endl;
      cout << tr() << endl;
      cout << table() << endl;

      cout << "</TD>" << "</TR>" << endl;
    }
    cout << "</TABLE>" << endl; 
  return 1;
}
