/* $Id: visor_menu.cpp 123 2009-06-14 16:36:20Z gbv $ */
/***************************************************************************
 *   Copyright (C) 2009 by Guillermo Ballester Valor                       *
 *   gbv@oxixares.com                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*!
  \file visor_menu.cpp
  \brief This file contains html design squeleton a menus
*/
#include "visor.h"

int print_prolog(met_station& e)
{
  cout << "<!-- Comienza el armazon del prologo -->" << endl;
  cout << "<table width='100%' border=1 cellspacing='0' cellpadding='10'>" << endl;
  cout << "<TR>" << endl;
  cout << "<TD bgcolor='#BBDDDD' width='10%' align='center'>" << endl;
  cout << "<DIV><font color='#203090' size='+1'><b>Visor</b></font></DIV>" << endl;
  cout << "<DIV><font size='-1'>Visualizador de datos de estaciones meteorológicas</font><DIV>" << endl;
  cout << "</TD>" << endl;
  cout << "<TD align='center' width='90%' bgcolor='#EEFFDD'>" << endl;
  cout << "<h1><font color='#A03030'>" << e.conf.name << "</font></h1>" << endl;
  cout << "</TD>" << endl;
  cout << "</TR>" << endl;

  cout << "<TR>" << endl;

  cout << "<!--barra izquierda-->" << endl;
  cout << "<TD align='center' valign='top' bgcolor='#EEFFEE'>" << endl;
  print_menu();
  cout << "<!-- fin de barra izquierda -->" << endl;
  cout << "</TD>" << endl;
  cout << "<TD valign='top'>" << endl;
  cout << "<!--nucleo, fin del prologo -->" << endl;
  return 1;
}

int print_epilog(void)
{
  cout << "<!--comienzo del epilogo-->" << endl;
  cout << "</TD>" << endl;
  cout << "</TR>" << endl;
  cout << "<TR>" << endl;
  cout << "<TD  align='center' colspan='2' bgcolor='#FFFFDD'>" << endl;
  cout << "<!-- barra inferior -->" << endl;
  cout << "<DIV><FONT color='#902020' size='-1'>&#169; Copyright G. Ballester Valor 2009</FONT></DIV>" << endl;
  cout << "<DIV><FONT color='#202090' size='-1'>License GPL v 3.0</FONT></DIV>" << endl;
  cout << "<!-- fin de barra inferior -->" << endl;
  cout << "</TD>" << endl;
  cout << "</TR>" << endl;
  cout << "</table>" << endl;
  cout << "<!-- fin del epilogo-->" << endl;

  return 1;
}

int print_css(void)
{
  cout << "<style type='text/css'>" << endl;
  cout << ".leftbar { font-size : x-small } " << endl;
  cout << "</style>" << endl;
  return 1;
}

int print_menu(void)
{
  int i;
  char sux[64];
  struct tm tmi;

  cout << "<DIV><font size='-1'><b>Selecciona los elementos que quieras ver</b></font></DIV>" << endl;
  cout << "<FORM action='./visor' method='GET'>" << endl;

  cout << "<table align='center'>" << endl;

  cout << "<tr><td align=center class=leftbar>" << endl;
  cout << "<hr>Ver último dato<br>" << endl;
  cout << "<INPUT Class=leftbar type=radio name='last' value='y' ";
  if (NOW)
     cout <<" CHECKED >Sí" << endl;
  else
     cout <<">Sí" << endl;
  cout << "<INPUT Class=leftbar type=radio name='last' value='n' ";
  if (NOW == 0)
     cout <<" CHECKED >No" << endl;
  else
     cout <<">No" << endl;
  cout << "</td></tr>" << endl;

  cout << "<tr><td align=center class=leftbar>" << endl;
  cout << "<hr>Días resumen diario<br>" << endl;
  cout << "(0 = no ver resumen)<br>" << endl;
  cout << "<INPUT Class=leftbar type=text NAME=nd size=4 maxlength=3 value="<< ND << ">" << endl;
  cout << "</td></tr>" << endl;

  cout << "<tr><td align=center class=leftbar>" << endl;
  cout << "Desde AAAAMMDD<br>" << endl;
  cout << "<INPUT Class=leftbar type=text NAME=fecha size=8 maxlength=8 " ;
  if (SHOWLAST)
    cout << "value=ahora>" << endl;
  else
    {
       gmtime_r(&TBEGIN, &tmi);
       strftime(sux,64,"%Y%m%d", &tmi);
       cout << "value=" << sux << ">" << endl;
    }
  cout << "</td></tr>" << endl;

  // Menu para ver graficos 

  cout << "<tr><td align=center class=leftbar>" << endl;
  cout << "<hr>GRÁFICOS<br>" << endl;
  cout << "<SELECT Class=leftbar name='ndg'>" << endl;
  cout << "<OPTION value='0' ";
  if (NDG == 0)
    cout << "SELECTED";
  cout << ">Sin gráficos</OPTION>" << endl;

  cout << "<OPTION value='1' ";
  if (NDG == 1)
    cout << "SELECTED";
  cout << ">1 día</OPTION>" << endl;

  cout << "<OPTION value='2' ";
  if (NDG == 2)
    cout << "SELECTED";
  cout << ">2 días</OPTION>" << endl;

  cout << "<OPTION value='3' ";
  if (NDG == 3)
    cout << "SELECTED";
  cout << ">3 días</OPTION>" << endl;

  cout << "<OPTION value='7' ";
  if (NDG == 7)
    cout << "SELECTED";
  cout << ">7 días</OPTION>" << endl;
  cout << "</SELECT>" << endl;
  cout << "</td><tr>" << endl;
 
  cout << "<tr><td align=left class=leftbar>" << endl;
  // bucle para los graficos a pintar 
  for (i = 0 ; i < NGARGS; i++)
  {
    cout << "<INPUT type=checkbox value='y' name='" << GARGS[i] << "'";
    if (GTASK_MASK & GARGS_M[i])
      cout << " CHECKED" ;
    cout << ">" << GARGS_NAME[i] << "<br> " << endl;
  }
  cout << "</td><tr>" << endl;
 
  cout << "</table>" << endl; 


  cout << "<BUTTON TYPE=submit>ver<BUTTON>" << endl;
  cout << "</FORM>" << endl;
  return 1;
}