/* $Id: wwsreader.h 90 2009-05-31 22:00:39Z gbv $ */
/***************************************************************************
 *                                                                         *
 *   wwsr - Wireless Weather Station Reader                                *
 *   2007 dec 19, Michael Pendec (michael.pendec@gmail.com)                *
 *   Version 0.1                                                           *
 *   2008 jan 24 Svend Skafte (svend@skafte.net)                           *
 *   Modifications for different firmware version(?)                       *
 *   2009 Jan 21 Guillermo Ballester gbv@oxixares.com                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*! \file wwsreader.h
    \brief include file for wwsr
*/
#include "wwsr.h"
extern int VIEWMASK;
extern struct usb_dev_handle *devh;
extern int ret, mempos, resetws, pdebug;
extern unsigned char    LOGBUF[MEMSIZE], CURBUF[32];
extern char usbmsg[16], *endptr;
extern unsigned char    buf2[400];
extern char wd[17][4];
extern struct extrem_data hin_max, hin_min, tin_max, tin_min, hout_max, hout_min, tout_max, tout_min, chill_max,
        chill_min, dwp_max, dwp_min, apres_max, apres_min, rpres_max, rpres_min, wsp_max, gust_max,
        rh_max, rd_max, rw_max, rm_max, rt_max;
extern char BACKUPFILE[PATH_LEN], INPUTFILE[PATH_LEN], CALFILE[PATH_LEN];
extern char DATEBEGIN[16], DATEEND[16], WS_TIMEZONE[64], CSV_SEP[16];
extern int ONLYLAST, FROMFILE, EXTREM, NOCAL, LASTN, GMTOFF, TIMESET, NOVERBOSE;
extern double ALTITUDE;
extern time_t TBEGIN, TEND;
extern FILE *F;
extern struct station_cal CALWWSR, *CALSTATION;

#ifdef WITH_DB
extern int OVERWRITE, FROMDB, KILLDATA, CLIMAT, INTERP;
extern char DBFILE[PATH_LEN];
extern size_t INSERTED, REJECTED, ERRORS;
extern struct stat_summary Summary;
#endif

void _close_readw();
void _init_wread();
void _open_readw();
void _read_usb_msg(char *buffer);
void reset_ws(void);
void _send_usb_msg( char msg1[1],char msg2[1],char msg3[1],char msg4[1],char msg5[1],char msg6[1],char msg7[1],char msg8[1] );
struct usb_device *find_device(int vendor, int product);


void print_extreme(FILE *f, struct extrem_data *d, char *name, char *unit);
int read_arguments(int argc, char **argv);
size_t read_current(uint8_t *b, uint16_t current);
size_t read_station_buf( uint8_t *b , size_t limit);
void show_usage(void);
int write_backup_file(char *name, size_t nbytes);
size_t get_main_block(char *buf);
void print_obs(FILE *f, struct obs_data *o, char *sep, time_t tbegin, time_t tend, int viewmask);



